#ifndef INC_GMATH_H
#define INC_GMATH_H

//Game Maker real valued functions
//by BMF [IamBMF@gmail.com]
//fo' free
//26-03-2006

#include <stdlib.h>
#include <math.h>
#include <stdarg.h>

//in order to use this function you must call srand() before in your program
double random(double x);

double choose(char n, ...); //n is the number of options

double abs(double x);

int sign(double x);

//round(x) is in math.h

//floor(x) is in math.h

//ceil(x) is in math.h

double frac(double x);

//sqrt(x) is in math.h

double sqr(double x);

double power(double x, double n);

//exp(x) is in math.h

double ln(double x);

double log2(double x);

//log10(x) is in math.h

double logn(double n, double x); //n -> base

//sin(x) is in math.h

//cos(x) is in math.h

//tan(x) is in math.h

double arcsin(double x);

double arccos(double x);

double arctan(double x);

double arctan2(double x, double y);

double degtorad(double x);

double radtodeg(double x);

double min(char n, ...);

double max(char n, ...);

double mean(char n, ...);

double median(char n, ...); //this was the only one that required me to think xD

double point_distance(double x1, double y1, double x2, double y2);

double point_direction(double x1, double y1, double x2, double y2);

double lengthdir_x(double length, double dir); //dir in degrees

double lengthdir_y(double length, double dir); //dir in degrees

#endif
