#include "../headers/gmath.h"
#include <SDL/SDL.h>
#include "../headers/SpriteClass.h"
#include "../headers/SoundClass.h"
#include "../headers/BulletClass.h"
#include "../headers/ParticleClass.h"
#include "../headers/functions.h"
#include "../headers/defines.h"

extern Sprite mysprite;
extern Sound mysound;
extern Particle myparticle[100];

Bullet::Bullet()
{
	x = -100, y = -100, hspeed = 0.0, vspeed = 0.0, destroyed = 1, current_triangle = -1;
}

void Bullet::create( int _x, int _y, double _direction, bool _enemyb )
{
    destroyed = 0;
    x = _x;
    y = _y;
    direction = _direction;
    hspeed = cos( direction ) * 12;
    vspeed = sin( direction ) * 12;
    enemyb = _enemyb;
}

void Bullet::show()
{
	Draw_Texture(mysprite.get(SPR_BULLET_PISTOL), (int)x, (int)y, 8, 8, 8, 8, 0, 1, (int)radtodeg(direction));		
}

void Bullet::move( unsigned int terrain_grid[][9], unsigned int triangles)
{
	if (current_triangle == -1) //first time
	    set_triangle( terrain_grid, &current_triangle, (int)x, (int)y, triangles );	
	
    x += hspeed;
    y += vspeed;

	//destroy if outside room
//	if (x < 0 || x > level_w || y < 0 || y > level_h)
	//	destroyed = 1;
		

	/*for (char i = 0; i < 100; i++)
	{
		if (myparticle[i].get_destroyed())
		{
			myparticle[i].create((int)x, (int)y, 255, 255, 255, 2);
			break;
		}
	}*/


/*
    //destroy if colliding with walls or outside room
    if ( levelgrid[ (int) x / 32 ][ (int) y / 32] == 1 || (int) x < 0 || (int) x > LEVELW * 32 || (int) y < 0 || (int) y > LEVELH * 32 )
    {
        create_particles( 10, (int) x, (int) y, &c_white );
        destroyed = 1;
    }

    //collisions with player
    if (enemyb)
    {
        if ( x > myplayer.get_x() && x < myplayer.get_x() + 32 && y > myplayer.get_y() && y < myplayer.get_y() + 32 )
        {
            timeleft = (int) max( 2, 0.0, (double) timeleft - 5.0 );
            create_particles( 10, (int) x, (int) y, &c_blue );
            destroyed = 1;
        }
    }
    else //collisions with enemies
    {
        char i;
        for( i = 0; i < maxenemies; i++ )
        {
            if ( !myenemy[i].get_destroyed() && x > myenemy[i].get_x() && x < myenemy[i].get_x() + 32 && y > myenemy[i].get_y() && y < myenemy[i].get_y() + 32 )
            {
                myenemy[i].hit();
                create_particles( 10, (int) x, (int) y, &c_purple );
                destroyed = 1;
                break;
            }
        }
    }*/
}

bool Bullet::get_destroyed()
{
    return destroyed;
}

void Bullet::destroy()
{
    destroyed = 1;
}
