#include "../headers/gmath.h"
#include <SDL/SDL.h>
#include <SDL/SDL_gfxPrimitives.h>
#include <SDL/SDL_opengl.h>

#include "../headers/ParticleClass.h"

Particle::Particle()
{
	x = -100, y = -100, hspeed = 0.0, vspeed = 0.0, destroyed = 1, size = 0;
}

void Particle::create( int _x, int _y, unsigned char r, unsigned char g, unsigned char b, int speed )
{
    destroyed = 0, x = _x, y = _y, health = 10, color_r = r, color_g = g, color_b = b, direction = random( 360 ), hspeed = lengthdir_x( speed, direction ), vspeed = lengthdir_y( speed, direction );
} 

void Particle::show()
{
	glDisable(GL_TEXTURE_2D);
	glPointSize(1.0);    	
	glBegin( GL_POINTS );		
	glColor3f((double)color_r/255.0,(double)color_g/255.0,(double)color_b/255.0);			
	glVertex2f( x, y );							
	glColor3f(1.0,1.0,1.0);			
	glEnd();	
	glEnable(GL_TEXTURE_2D);
}

void Particle::move()
{
    health = (char) max( 2, 0.0, (double) health - 1.0 );
    if ( !health )
        destroyed = 1;

    x += hspeed;
    
    vspeed = min( 2, vspeed + .2, 10.0 );
        
    y += vspeed;
}

bool Particle::get_destroyed()
{
    return destroyed;
}

void Particle::destroy()
{
    destroyed = 1;
}
