#include <SDL/SDL.h>
#include <SDL/SDL_opengl.h>
#include "../headers/SoundClass.h"
#include "../headers/functions.h"
#include "../headers/defines.h"

Sound::Sound()
{
	Mix_OpenAudio(MIX_DEFAULT_FREQUENCY, MIX_DEFAULT_FORMAT, 2, 1024);	
}

void Sound::load()
{
	sample[SND_PLAYER_LAND] = Mix_LoadWAV("resources/land.wav");
	sample[SND_PLAYER_JUMP] = Mix_LoadWAV("resources/jump.wav");
	sample[SND_PLAYER_FOOTSTEP] = Mix_LoadWAV("resources/footstep.wav");
	ogg[MUS_JUNGLE_1] = Mix_LoadMUS("resources/jungle1.ogg");	
}

void Sound::play_sound( unsigned int sound )
{
	Mix_PlayChannel(-1, sample[sound], 0);
}

void Sound::sound_set_volume(unsigned int sound, unsigned char volume)
{
	Mix_VolumeChunk(sample[sound], volume);
}

bool Sound::sound_is_playing(unsigned int sound)
{
	for(char i = 0; i < 8; i++)
		if (Mix_GetChunk(i) == sample[sound]) //find channel
			if (Mix_Playing(i)) //check if it's playing
				return 1;
	return 0;
}

void Sound::play_music( unsigned int music )
{
	Mix_PlayMusic(ogg[music], -1);
}
